Commit 79619f95 authored by Robin Vobruba's avatar Robin Vobruba
Browse files

Initial commit

parents
# SPDX-FileCopyrightText: 2022 Robin Vobruba <hoijui.quaero@gmail.com>
#
# SPDX-License-Identifier: Unlicense
/target/
This diff is collapsed.
This diff is collapsed.
Creative Commons Legal Code
CC0 1.0 Universal
CREATIVE COMMONS CORPORATION IS NOT A LAW FIRM AND DOES NOT PROVIDE
LEGAL SERVICES. DISTRIBUTION OF THIS DOCUMENT DOES NOT CREATE AN
ATTORNEY-CLIENT RELATIONSHIP. CREATIVE COMMONS PROVIDES THIS
INFORMATION ON AN "AS-IS" BASIS. CREATIVE COMMONS MAKES NO WARRANTIES
REGARDING THE USE OF THIS DOCUMENT OR THE INFORMATION OR WORKS
PROVIDED HEREUNDER, AND DISCLAIMS LIABILITY FOR DAMAGES RESULTING FROM
THE USE OF THIS DOCUMENT OR THE INFORMATION OR WORKS PROVIDED
HEREUNDER.
Statement of Purpose
The laws of most jurisdictions throughout the world automatically confer
exclusive Copyright and Related Rights (defined below) upon the creator
and subsequent owner(s) (each and all, an "owner") of an original work of
authorship and/or a database (each, a "Work").
Certain owners wish to permanently relinquish those rights to a Work for
the purpose of contributing to a commons of creative, cultural and
scientific works ("Commons") that the public can reliably and without fear
of later claims of infringement build upon, modify, incorporate in other
works, reuse and redistribute as freely as possible in any form whatsoever
and for any purposes, including without limitation commercial purposes.
These owners may contribute to the Commons to promote the ideal of a free
culture and the further production of creative, cultural and scientific
works, or to gain reputation or greater distribution for their Work in
part through the use and efforts of others.
For these and/or other purposes and motivations, and without any
expectation of additional consideration or compensation, the person
associating CC0 with a Work (the "Affirmer"), to the extent that he or she
is an owner of Copyright and Related Rights in the Work, voluntarily
elects to apply CC0 to the Work and publicly distribute the Work under its
terms, with knowledge of his or her Copyright and Related Rights in the
Work and the meaning and intended legal effect of CC0 on those rights.
1. Copyright and Related Rights. A Work made available under CC0 may be
protected by copyright and related or neighboring rights ("Copyright and
Related Rights"). Copyright and Related Rights include, but are not
limited to, the following:
i. the right to reproduce, adapt, distribute, perform, display,
communicate, and translate a Work;
ii. moral rights retained by the original author(s) and/or performer(s);
iii. publicity and privacy rights pertaining to a person's image or
likeness depicted in a Work;
iv. rights protecting against unfair competition in regards to a Work,
subject to the limitations in paragraph 4(a), below;
v. rights protecting the extraction, dissemination, use and reuse of data
in a Work;
vi. database rights (such as those arising under Directive 96/9/EC of the
European Parliament and of the Council of 11 March 1996 on the legal
protection of databases, and under any national implementation
thereof, including any amended or successor version of such
directive); and
vii. other similar, equivalent or corresponding rights throughout the
world based on applicable law or treaty, and any national
implementations thereof.
2. Waiver. To the greatest extent permitted by, but not in contravention
of, applicable law, Affirmer hereby overtly, fully, permanently,
irrevocably and unconditionally waives, abandons, and surrenders all of
Affirmer's Copyright and Related Rights and associated claims and causes
of action, whether now known or unknown (including existing as well as
future claims and causes of action), in the Work (i) in all territories
worldwide, (ii) for the maximum duration provided by applicable law or
treaty (including future time extensions), (iii) in any current or future
medium and for any number of copies, and (iv) for any purpose whatsoever,
including without limitation commercial, advertising or promotional
purposes (the "Waiver"). Affirmer makes the Waiver for the benefit of each
member of the public at large and to the detriment of Affirmer's heirs and
successors, fully intending that such Waiver shall not be subject to
revocation, rescission, cancellation, termination, or any other legal or
equitable action to disrupt the quiet enjoyment of the Work by the public
as contemplated by Affirmer's express Statement of Purpose.
3. Public License Fallback. Should any part of the Waiver for any reason
be judged legally invalid or ineffective under applicable law, then the
Waiver shall be preserved to the maximum extent permitted taking into
account Affirmer's express Statement of Purpose. In addition, to the
extent the Waiver is so judged Affirmer hereby grants to each affected
person a royalty-free, non transferable, non sublicensable, non exclusive,
irrevocable and unconditional license to exercise Affirmer's Copyright and
Related Rights in the Work (i) in all territories worldwide, (ii) for the
maximum duration provided by applicable law or treaty (including future
time extensions), (iii) in any current or future medium and for any number
of copies, and (iv) for any purpose whatsoever, including without
limitation commercial, advertising or promotional purposes (the
"License"). The License shall be deemed effective as of the date CC0 was
applied by Affirmer to the Work. Should any part of the License for any
reason be judged legally invalid or ineffective under applicable law, such
partial invalidity or ineffectiveness shall not invalidate the remainder
of the License, and in such case Affirmer hereby affirms that he or she
will not (i) exercise any of his or her remaining Copyright and Related
Rights in the Work or (ii) assert any associated claims and causes of
action with respect to the Work, in either case contrary to Affirmer's
express Statement of Purpose.
4. Limitations and Disclaimers.
a. No trademark or patent rights held by Affirmer are waived, abandoned,
surrendered, licensed or otherwise affected by this document.
b. Affirmer offers the Work as-is and makes no representations or
warranties of any kind concerning the Work, express, implied,
statutory or otherwise, including without limitation warranties of
title, merchantability, fitness for a particular purpose, non
infringement, or the absence of latent or other defects, accuracy, or
the present or absence of errors, whether or not discoverable, all to
the greatest extent permissible under applicable law.
c. Affirmer disclaims responsibility for clearing rights of other persons
that may apply to the Work or any use thereof, including without
limitation any person's Copyright and Related Rights in the Work.
Further, Affirmer disclaims responsibility for obtaining any necessary
consents, permissions or other rights required for any use of the
Work.
d. Affirmer understands and acknowledges that Creative Commons is not a
party to this document and has no duty or obligation with respect to
this CC0 or use of the Work.
This is free and unencumbered software released into the public domain.
Anyone is free to copy, modify, publish, use, compile, sell, or distribute this software, either in source code form or as a compiled binary, for any purpose, commercial or non-commercial, and by any means.
In jurisdictions that recognize copyright laws, the author or authors of this software dedicate any and all copyright interest in the software to the public domain. We make this dedication for the benefit of the public at large and to the detriment of our heirs and
successors. We intend this dedication to be an overt act of relinquishment in perpetuity of all present and future rights to this software under copyright law.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
For more information, please refer to <http://unlicense.org/>
<!--
SPDX-FileCopyrightText: 2022 Robin Vobruba <hoijui.quaero@gmail.com>
SPDX-License-Identifier: CC0-1.0
-->
# OHO to GitLab - OSH project format converter
[![REUSE status](
https://api.reuse.software/badge/gitlab.opensourceecology.de/verein/projekte/dokumentation-bekanntmachung-von-open-hardware-regenerativer-energie-projekte/oho2gitlab)](
https://api.reuse.software/info/gitlab.opensourceecology.de/verein/projekte/dokumentation-bekanntmachung-von-open-hardware-regenerativer-energie-projekte/oho2gitlab)
TODO
<!--
SPDX-FileCopyrightText: 2022 Robin Vobruba <hoijui.quaero@gmail.com>
SPDX-License-Identifier: CC0-1.0
-->
1. [ ] READMEs ausfüllen & ins repo laden
2. [x] Lizenz ins repo laden (je Projekt unterschiedlich)
3. [x] Ordner 'old versions' löschen
4. [x] export files (STP, STL, PDF etc.) separat speichern
(nicht im repo), fuer spaeter (siehe 7.)
5. [x] Stückliste von Dietrich anfordern & säubern
* [ ] nach Format der bereits hochgeladenen Stücklisten
5. [ ] diesen gesäuberten Stand ins OSEG-GitLab laden
6. [x] im OSEG-GitLab-Repo tag `v1.0.0` setzen
7. [ ] Release mit diesem tag veröffentlichen
**mit** den vormals gelöschten export files als export package
(heruntergeladen von der jeweiligen OHO-Seite)
<!--
SPDX-FileCopyrightText: ${YEAR} ${PROJECT_AUTHOR}
SPDX-License-Identifier: ${PROJECT_LICENSE}
-->
# ${PROJECT_NAME}
_${PROJECT_DESCRIPTION}_
![](${PROJECT_IMAGE_PATH})
Where to find the files:
| | |
|---|---|
| Bill of Materials | [BoM](bom.csv) |
| CAD files | [/CAD/](cad/) |
| export files | in the [release](${PROJECT_RELEASE_URL}) |
| assembly instructions | see PDF drawings in the [release](${PROJECT_RELEASE_URL}) |
#### What are "export files"?
Those are STP models, PDF drawings etc. exported from the source files
(native CAD files etc.) that can be found in this repo.
#### Why are export files not in the repository and only in the release?
Git cannot handle binaries in a reasonable manner.
However, for most CAD formats, we cannot change this,
but keeping (naturally mostly) outdated export files
in a decentralised version control system doesn't really make sense.
So work happens here in the repo; you'll find all necessary source files here.
We provide exports in interchangeable formats for every [release](${PROJECT_RELEASE_URL})
so you don't need to procure expensive or specialised software
to access the actual information (e.g. to build the hardware).
#### Why is there no step-by-step instruction for building the hardware?
We tried our best to make the PDF drawings as intuitive as possible
so that the assembly (incl. the order of assembly) becomes clear from the drawings.
If that's not the case for you, please feel free to drop us an issue.
Step-by-step guides are very hard to maintain for us,
so we avoided them for the moment.
#### Which software has been used for the CAD files?
We used Autodesk Fusion 360.
If you're experienced with FreeCAD or openSCAD,
we'd love to rebuild our files with you.
## Attestation according to DIN SPEC 3105-2
**This hardware** (specifically v1.0.0)
**got peer-reviewed by other OSH developers
and officially qualifies as Open-Source-Hardware
according to DIN SPEC 3105-2**
- issuing authority:
[Open Hardware Observatory](https://en.oho.wiki/)
- [attestation](${PROJECT_ATTESTATION_PATH})
- [review details](${PROJECT_REVIEW_DETAILS_URL_OR_PATH})
## Having Issues Rebuilding the Project?
Drop us an issue!
We're keen to help :)
## How to Contribute?
At the moment we don't have a proper contribution guide.
If you're willing to participate you can either drop us an issue
or meet us directly in [OSEG's Welcome Channel](https://t.me/OSEGWelcome)
on Telegram.
Looking forward to e-meet you :)
SPDX-FileCopyrightText: 2022 Robin Vobruba <hoijui.quaero@gmail.com>
SPDX-License-Identifier: CC0-1.0
https://en.oho.wiki/wiki/Axial_Flow_Turbine_25kW
https://en.oho.wiki/wiki/Cross_Flow_Turbine
https://en.oho.wiki/wiki/DIY_Solar_Water_Heater
https://en.oho.wiki/wiki/Floating_Dome_Biodigestor
https://en.oho.wiki/wiki/Himalayan_Water_Wheel
https://en.oho.wiki/wiki/Horizontal_Shaft_Turbine_With_Security_Tail
https://en.oho.wiki/wiki/Lattice_Tower_Mast_for_Wind_Turbine
https://en.oho.wiki/wiki/Parabolic_Solar_Cooker_with_Aluminium_Reflector
https://en.oho.wiki/wiki/Savonius_Rotor_of_1m_Diameter
https://en.oho.wiki/wiki/Savonius_Rotor_with_Two_Blade_Levels
https://en.oho.wiki/wiki/Segner_Turbine_for_4m_Pit
https://en.oho.wiki/wiki/Small_water_turbine
https://en.oho.wiki/wiki/Solar_Food_Dryer_for_Vegetables
https://en.oho.wiki/wiki/Solar_Water_Heater_with_Corrugated_Metal_Collector
https://en.oho.wiki/wiki/Solar_Water_Heater_with_Serpentine_Collector
https://en.oho.wiki/wiki/Tubular_Plastic_Biodigester
https://en.oho.wiki/wiki/Vertical_Axis_Sail_Windmill_-_Diameter_3_m
https://en.oho.wiki/wiki/Wind_Mill_Pump
https://en.oho.wiki/wiki/Windmill_Blades_-_Diameter_1.5_to_3_m
https://en.oho.wiki/wiki/Zigzag_Solar_water_heater
SPDX-FileCopyrightText: 2022 Robin Vobruba <hoijui.quaero@gmail.com>
SPDX-License-Identifier: CC0-1.0
#!/usr/bin/env bash
#
# SPDX-FileCopyrightText: 2022 Robin Vobruba <hoijui.quaero@gmail.com>
# SPDX-License-Identifier: AGPL-3.0-or-later
#
# See the output of "$0 -h" for details.
# Exit immediately on each error and unset variable;
# see: https://vaneyckt.io/posts/safer_bash_scripts_with_set_euxo_pipefail/
set -Eeuo pipefail
#set -Eeu
script_dir=$(dirname "$(readlink -f "${BASH_SOURCE[0]}")")
APP_NAME="OHO crawler"
script_name="$(basename "$0")"
DEFAULT_SAVE_DIR="target"
DEFAULT_PROJECTS_FILE="res/projects_urls.csv"
projects_file="$DEFAULT_PROJECTS_FILE"
DEFAULT_README_TEMPLATE_FILE="res/README-TEMPLATE.md"
readme_template_file="$DEFAULT_README_TEMPLATE_FILE"
force=false
gitlab_user="${GITLAB_USER:-$USER}"
gitlab_token="${GITLAB_TOKEN:?}"
repos_host="https://gitlab.opensourceecology.de"
#repos_org="verein"
repos_org="hoijui"
#repos_base_structure="projekte/dokumentation-bekanntmachung-von-open-hardware-regenerativer-energie-projekte"
# repos_base="$repos_host/$repos_org/$repos_base_structure"
repos_base="$repos_host/$repos_org"
print_help() {
echo "$APP_NAME - Crawls (fetches & parses) OHO.wiki project sites."
echo
echo "Usage:"
echo " $script_name [OPTIONS] [save-dir]"
echo "Options:"
echo " -f, --force Re-download alreayd downloaded files"
echo " -p, --projects [FILE] List of project URLs, one per line"
echo " -h, --help Print this usage help and exit"
echo "Examples:"
echo " $script_name"
echo " $script_name target"
echo " $script_name --help"
}
# read command-line args
POSITIONAL=()
while [[ $# -gt 0 ]]
do
arg="$1"
shift # $2 -> $1, $3 -> $2, ...
case "$arg" in
-f|--force)
force=true
;;
-p|--projects)
projects_file="$1"
shift
;;
-h|--help)
print_help
exit 0
;;
*) # non-/unknown option
POSITIONAL+=("$arg")
;;
esac
done
set -- "${POSITIONAL[@]}" # restore positional parameters
save_dir="${1:-$DEFAULT_SAVE_DIR}"
mkdir -p "$save_dir"
if ! which fdfind > /dev/null
then
>&2 echo "ERROR: Required utility 'fdfind' (package: 'fd-find') not found. Please install it!"
exit 33
fi
if ! which rg > /dev/null
then
>&2 echo "ERROR: Required utility 'rg' (package: 'ripgrep') not found. Please install it!"
exit 33
fi
if ! which reuse > /dev/null
then
>&2 echo "ERROR: Required utility 'reuse' (package: 'reuse') not found. Please install it!"
exit 33
fi
if ! which lab > /dev/null
then
>&2 echo "ERROR: Required utility 'lab' (<https://github.com/zaquestion/lab>) not found. Please install it!"
exit 33
fi
if ! which projvar > /dev/null
then
>&2 echo "ERROR: Required utility 'projvar' (<https://github.com/hoijui/projvar>) not found. Please install it!"
exit 33
fi
if ! which repvar > /dev/null
then
>&2 echo "ERROR: Required utility 'repvar' (<https://github.com/hoijui/repvar>) not found. Please install it!"
exit 33
fi
if [ ! -d "$save_dir" ]
then
>&2 echo "ERROR: Not a directory: '$save_dir'"
print_help
exit 1
fi
if [ ! -f "${projects_file:?}" ]
then
>&2 echo "ERROR: Not a file: '$projects_file'"
print_help
exit 1
fi
function dl() {
src="$1"
dst="$2"
# force means, re-download even if the file is already locally present
force="${3:-false}"
if $force || ! [ -e "$dst" ]
then
mkdir -p "$(dirname "$dst")"
echo -e "\tdl '$src'\n\t\tto '$dst' ..."
curl \
--silent \
--output "$dst" \
"$src"
fi
}
function extract_spdx_license() {
page_file="$1"
rg -i 'License:' "$page_file" \
| sed -e 's|\s*</p>$||' -e 's|.*>\s*||' -e 's|\s\+v\([0-9]\)|-\1|g' -e 's|\s\+|-|g'
}
function extract_organization() {
page_file="$1"
rg -i 'Organization:' "$page_file" \
| sed -e 's|\s*</p>$||' -e 's|.*>\s*||'
}
function extract_links() {
page_orig="$1"
links_file="$2"
base_url="$3"
rg href "$page_orig" \
| sed -e 's|href=|\nhref=|g' \
| rg href \
| sed -e 's|.*href="||' -e 's|".*||' \
| rg -e "\.(pdf|jpe?g|zip|png|svg|gif)\$" -e "rdf" \
| sed -e 's|^/|'"$base_url"'/|' \
| rg -v "wiki_32x32.png" \
| sort -u \
> "$links_file"
num_links="$(wc -l < "$links_file")"
num_unique_files="$(sed -e 's|.*/||' < "$links_file" | sort -u | wc -l)"
if [ "$num_links" -ne "$num_unique_files" ]
then
>&2 echo "ERROR: There are duplicate file-names for this project!"
>&2 echo " see '$links_file'"
exit 1
fi
}
function extract_parts_table() {
page_file="$1"
csv_file="$2"
# We filter out just the table we are interested in with AWK,
# then lay the PDF links bare (as plain text),
# and then convert the whoel table from HTML into CSV.
awk '
found { if (inside) { print } }
/id="Parts_list"/ { found = 1; inside = 1 }
/<\/table>/ { inside = 0 }
' < "$page_file" \
| tr -d '\n' | # delete newlines
sed 's/<a [^>]*href="\(http[^"]\+\)"[^>]*>PDF<\/a>/\1/g' | # lay PDF links bare
sed 's/<tr[^>]*>/\n/g' | # convert tr tags into newlines to break data into table rows
sed 's/<[^>]*t[dh]>/,/g' | # convert closing td and th tags into commas
sed 's/<[^>]*>//g' | # delete all other html tags
awk '(FNR + 1) % 2' | # delete every second row (the first two are empty, and the others contain only "Add Review")
cut -d, -f1,3,5,7,9,11,13,15,16 --complement | # delete every second column, as they are empty or undesired
sed -e 's|,\(http.*/\(.*\)\)|[\2](generated/assets/img/\2) ([orig](/1))|' > "$csv_file" # convert links to PDFs into local path + orig-URL (in Markdown)
}
function extract_main_image_path() {
dir_dl="$1"
fdfind '.*\.(jpe?g|png|gif|svg)' "$dir_dl" \
| awk '{ print length, $0 }' \
| sort -n \
| cut -d" " -f2- \
| head -n 1 \
| sed 's|.*/|generated/assets/img/|g'
}
function extract_attestation_path() {
dir_dl="$1"
fdfind 'Attestation_.*\.pdf' "$dir_dl" \
| sed 's|.*/|generated/assets/img/|g'
}
function download_project_content() {
while read -r file_url
do
repo_path="${file_url##*/}"
repo_path="${repo_path##File:}"
dl_local_file="$dir_dl/$repo_path"
if echo "$repo_path" | rg -q -e "\.(pdf|jpe?g|png|svg|gif)\$"
then
#repo_path="assets/img/$repo_path"
repo_path="$repo_path"
elif echo "$repo_path" | rg -q -e "\.(zip)\$"
then
sub_dir="${repo_path##*_}"
sub_dir="${sub_dir%-files.zip}"
sub_dir="$(echo "$sub_dir" | awk '{print tolower($0)}')"
repo_path="${sub_dir}.zip"
elif echo "$repo_path" | rg -q -e "rdf"
then
repo_path="meta.rdf"
fi
if ! [ -e "$dl_local_file" ] && echo "$file_url" | rg '/File:' --quiet
then
# This is a link not to a file directly,
# but to a page with meta-data about,
# and the link to the actual file.
# Thus, we download that apge, and extract the link from it.
tmp_page_file="/tmp/crawl_${RANDOM}_$(basename "$repo_path").html"
dl "$file_url" "$tmp_page_file"
# Sample link ot orig on ".../File:..." page:
# <a href="https://cdata.oho.wiki/images/8/83/Attestation_Axial_Flow_Turbine_25kW.jpg" class="internal" title="Attestation Axial Flow Turbine 25kW.jpg">Original file</a>
file_url="$(tr -d '\n' < "$tmp_page_file" \
| sed -e 's|<a |\n<a |g' -e 's|</a>|</a>\n|g' \
| grep -e 'Original file</a>$' \
| sed -e 's|.* href="\([^"]\+\)".*|\1|g')"
rm "$tmp_page_file"
fi
dl "$file_url" "$dl_local_file"
done
}
# If the given dir containes only one dir in the root,
# move all its contents to the parent and delete it.
function flatten_if_single_dir() {
flatten_base_dir="$1"
dirs_l1="$(fdfind --maxdepth 1 \
. \
"$flatten_base_dir")"
dirs_l1_num="$(echo "$dirs_l1" | wc -l)"
if [ "$dirs_l1_num" -eq 1 ] && [ -d "$dirs_l1" ]
then
mv "$dirs_l1"/* "$(dirname "$dirs_l1")/"
rmdir "$dirs_l1"
fi
}
function add_repo_license() {
dir_repo="$1"
license_spdx="$2"
main_licnese="${3:-false}"
dir_licenses="$dir_repo/LICENSES"
reuse_license_file="$dir_licenses/${license_spdx}.txt"
mkdir -p "$dir_licenses"
reuse download \
--output "$reuse_license_file" \
"$license_spdx"
if $main_licnese
then
ln "$reuse_license_file" "$dir_repo/LICENSE"
fi
}
function ensure_empty_dir() {
clean_dir="$1"
mkdir -p "$clean_dir"
rm -Rf "$clean_dir"
mkdir -p "$clean_dir"
}
function clean_file_names_recursively() {
clean_dir="$1"
find "$clean_dir" -depth -name '* *' \
| while IFS= read -r path ; \
do \
mv -i "$path" "$(dirname "$path")/$(basename "$path"|tr ' ' _)" ; \
done
}
function clean_unzipped_dir() {
unzipped_dir="$1"
cont_name="$(basename "$unzipped_dir")"
clean_file_names_recursively "$unzipped_dir"
fdfind -i -0 \
'(^lockfile[.]lck$|^OldVersions$|^new_folder$|borrar)' \
"$unzipped_dir" \
| xargs -0 rm -Rf
if [ "$cont_name" == "cad" ]
then
fdfind -i -0 \
'([.]ste?p$)' \
"$unzipped_dir" \
| xargs -0 rm -Rf
fi
}
while read -r proj_url
do
base_url="$(echo "$proj_url" | sed -e 's|\(https\?://[^/]*\).*$|\1|')"
proj_name="${proj_url##*/}"
dir_dl="$save_dir/dl/$proj_name"
dir_repo="$save_dir/repos/$proj_name"
dir_gen="$save_dir/generated/$proj_name"
#mkdir -p "$dir_dl"
page_orig="$dir_dl/page.html"
links_file="$dir_dl/links.csv"
echo "Processing '$proj_name' ..."
if [ "$proj_name" == "Solar_Water_Heater_with_Corrugated_Metal_Collector" ] # FIXME Already told Dietrich on Feb 19. 2022 in Telegram
then
>&2 echo "WARNING: Skipping because of OHO error on this page!"
continue
fi